
#INCLUDE IODEF.C

/* STATIC INT XXXZEI = 0; */
			/* GETCHAR, UNGETCHAR ZEICHEN */
			/* MIT UNGETC. BEREITGESTELLT */
EXTERN INT XXXZEI;	/* WEGEN ROM-FAEHIF */
STATIC INT UNGVAR[2];	/* NIMMT ZEICHEN VON UNGET-   */

/* Treiber fuer die serielle Schnittstelle des 8051
   7.12.86
*/

/*SERINIT()
{
/* INITIALISIERUNG DER SERIELLEN SCHNITTSTELLE */

/*=============================================*/
/* FESTLEGEN DER BETRIEBSART:
   es sind die Betriebsarten 0,1,2,3 moeglich
*/

#define	BETRIEBSART 1

/*=============================================*/
/* FESTLEGEN DER BAUDRATE:

Fuer die Betriebsart 0 gilt: F = XTAL/12 fest;

fuer die Betriebsart 2 gilt: F = XTAL/64 fest;

fuer die Betriebsarten 1+3 gilt:

bei gewuenschter Baudrate F ist der Timer T1 mit dem
negativen Wert der ganzzahligen Konstanten

 	@baud = K * 1 / ( 32 * F )

zu laden,
wobei K = XTAL/12 bei internem Takt fuer Timer 1
oder  K = externer Takt fuer Timer 1.



Beispiel fuer  11.0592 MHz Prozessortakt: */
#ASM

;@baud	EQU	-3	;9600 baud
;@baud	EQU	-6	;4800
;@baud	EQU	-12	;2400
;@baud	equ	-24	;1200

	ext	@baud:byte

#ENDASM


/*=============================================*/
/* FESTLEGEN DER PARITAET
BETRIEBSART 1:
NON	 = 8 Bit/char,
EVEN,ODD = 7 Bit/Char + Parity,

BETRIEBSART 2 und 3:
8 Bit/Char + Parity
*/

#ASM
NON	EQU	0
EVEN	EQU	1
ODD	EQU	2

PARITY	EQU	NON

	public	@xxioini
@xxioini

#ENDASM


#if BETRIEBSART == 0

#ASM
; Initialisierung fuer Betriebsart 0:
; synchrone Ein-/Ausgabeerweiterung
;
	mov	SCON,#00010001B	; BETRIEBSART 0
				; Empfaengerfreigabe
				; reset Transmitter-Interrupt
				; set Receiver-Interrupt

#ENDASM

#endif

#if BETRIEBSART == 1

#ASM
; Initialisierung fuer Betriebsart 1:
;   asynchrone Datenuebertragung mit 10-Bit Frames
;   und variabler Uebertragungsrate

	mov	SCON,#01010010B	; BETRIEBSART 1
				; Empfaengerfreigabe
				; set Transmitter-Interrupt
				; reset Receiver-Interrupt
	mov	TMOD,#00100000B	; TIMER 1 in MODE 2
				; AUTORELOAD
				; interner Takt
	mov	TH1,#@baud	; lade Timer mit Teiler
	clr	0ABH		; sperre Interrupt (ET1)
	setb	TR1		; Start Timer 1
#ENDASM

#endif

#if BETRIEBSART == 2

#ASM
; Initialisierung fuer Betriebsart 2:
; asynchrone Datenuebertragung mit 11-Bit Frames
; und fester Uebertragungsrate

	mov	SCON,#10011010B	; BETRIEBSART 2
				; Empfaengerfreigabe
				; set Transmitter-Interrupt
				; reset Receiver-Interrupt
#ENDASM

#endif

#if BETRIEBSART == 3

#ASM
; Initialisierung fuer Betriebsart 3:
; asynchrone Datenuebertragung mit 11-Bit Frames
; und variabler Uebertragungsrate

	mov	SCON,#11011010B	; BETRIEBSART 3
				; Empfaengerfreigabe
				; set Transmitter-Interrupt
				; reset Receiver-Interrupt
	mov	TMOD,#00100000B	; TIMER 1 in MODE 2
				; AUTORELOAD
				; interner Takt
	mov	TH1,#@baud	; lade Timer mit Teiler
	clr	0ABH		; sperre Interrupt (ET1)
	setb	TR1		; Start Timer 1
#ENDASM

#endif
#asm
	ret
#endasm
/* } */



PUTCHAR(C)
INT C;
{

#ASM
 EXTRN	@ccgetl
#ENDASM

#if BETRIEBSART == 0

#ASM
	mov	dptr,#2		; 2 Byte vom externen Stack holen
	lcall	@ccgetl		; und nach r1,r0
	clr	TI		; Sender-Flag loeschen
	mov	SBUF,r0		; low Byte nach SBUF
put0:	jnb	TI,put0		; loop, bis SBUF-Senderegister leer

#ENDASM

#endif   

#if BETRIEBSART == 1

#ASM
put1:	jnb	TI,put1		; loop, bis SBUF-Senderegister leer
	mov	dptr,#2		; 2 Byte vom externen Stack holen
	lcall	@ccgetl		; und nach r1,r0
	mov	a,r0

	if 	PARITY == EVEN
	mov	c,p		; Paritybit in den Carry
	mov	0E7H,c		; setze Bit 7
	endif

	if	PARITY == ODD
	mov	c,p		; Paritybit in den Carry
	cpl	c		; Complement
	mov	0E7H,c		; setze Bit 7
	endif

	mov	SBUF,a		; Zeichen nach SBUF
	clr	TI		; Sender-Flag loeschen
#ENDASM

#endif


#if (BETRIEBSART == 2)

#ASM
put2:	jnb	TI,put2		; loop, bis SBUF-Senderegister leer
	mov	dptr,#2		; 2 Byte vom externen Stack holen
	lcall	@ccgetl		; und nach r1,r0
	mov	a,r0

	if	PARITY == EVEN
	mov	c,p		; Paritybit in den Carry
	mov	SCON.3,c	; setze 9. Bit
	endif

	if	PARITY == ODD
	mov	c,p		; Paritybit in den Carry
	cpl	c		; Complement
	mov	SCON.3,c	; setze 9. Bit
	endif

	mov	SBUF,a		; Zeichen nach SBUF
	clr	TI		; Sender-Flag loeschen
#ENDASM
#endif

#if (BETRIEBSART == 3)

#ASM
put3:	jnb	TI,put3		; loop, bis SBUF-Senderegister leer
	mov	dptr,#2		; 2 Byte vom externen Stack holen
	lcall	@ccgetl		; und nach r1,r0
	mov	a,r0

	if	PARITY == EVEN
	mov	c,p		; Paritybit in den Carry
	mov	SCON.3,c	; setze 9. Bit
	endif

	if	PARITY == ODD
	mov	c,p		; Paritybit in den Carry
	cpl	c		; Complement
	mov	SCON.3,c	; setze 9. Bit
	endif

	mov	SBUF,a		; Zeichen nach SBUF
	clr	TI		; Sender-Flag loeschen
#ENDASM

#endif

}


GETCH()

{
   IF (XXXZEI)
	RETURN UNGVAR[--XXXZEI];
   ;

#if BETRIEBSART == 0

#ASM
	clr	RI		; Empfaenger-Flag loeschen
get0:	jnb	RI,get0		; loop, bis SBUF-Empfaengerreg. voll
	mov	r0,SBUF		; low Byte nach r0
	mov	r1,#0
#ENDASM

#endif   

#if BETRIEBSART == 1


#ASM
; A-Register ist <> 0, falls Paritaetsfehler

get1:	jnb	RI,get1		; loop, bis SBUF-Empfaengerreg. voll
	clr	RI		; Empfaenger-Flag loeschen
	mov	a,SBUF		; Zeichen nach a

	if	PARITY == NON
	mov	r0,a		; Zeichen nach r0
	clr	a
	endif

	if	PARITY == EVEN
	mov	c,p		; Paritybit in den Carry
	anl	a,#7FH		; maskiere 7 Bit
	mov	r0,a		; Zeichen nach r0
	clr	a
	mov	0E0H,c		; Carry in den Akku
  	endif

	if	PARITY == ODD
	mov	c,p		; Paritybit in den Carry
	cpl	c		; Complement
	anl	a,#7FH		; maskiere 7 Bit
	mov	r0,a		; Zeichen nach r0
	clr	a
	mov	0E0H,c		; Carry in den Akku
  	endif

	mov	r1,#0		; high byte = 0
#ENDASM

#endif


#if (BETRIEBSART == 2)


#ASM

get2:	jnb	RI,get2		; loop, bis SBUF-Empfaengerreg. voll
	clr	RI		; Empfaenger-Flag loeschen
	mov	r0,SBUF		; Zeichen nach r0
	clr	a

	if	PARITY == EVEN
	mov	c,SCON.2	; Paritybit in den Carry
	mov	0E0H,c		; Carry in den Akku
  	endif

	if	PARITY == ODD
	mov	c,SCON.2	; Paritybit in den Carry
	cpl	c		; Complement
	mov	0E0H,c		; Carry in den Akku
  	endif

	mov	r1,#0		; high byte = 0
#ENDASM

#endif


#if (BETRIEBSART == 3)

#ASM
; A-Register ist <> 0, falls Paritaetsfehler

get3:	jnb	RI,get3		; loop, bis SBUF-Empfaengerreg. voll
	clr	RI		; Empfaenger-Flag loeschen
	mov	r0,SBUF		; Zeichen nach r0
	clr	a

	if	PARITY == EVEN
	mov	c,SCON.2	; Paritybit in den Carry
	mov	0E0H,c		; Carry in den Akku
	endif

	if	PARITY == ODD
	mov	c,SCON.2	; Paritybit in den Carry
	cpl	c		; Complement
	mov	0E0H,c		; Carry in den Akku
	endif

	mov	r1,#0		; high byte = 0
#ENDASM

#endif

}

/*		*/
APUTCHAR(C)
INT C;
{
   IF ( C == '\N' ) 
	PUTCHAR('\R');
   RETURN PUTCHAR(C);
}
/*		*/
AGETCHAR()
{
   STATIC INT C;
   IF ( C == '\R')
	IF ( (C= GETCHAR()) != '\N')
	   GOTO CHP;
   C= GETCHAR();
 CHP:
   IF ( C != '\R')
	IF (C != 0X1A)
	   RETURN C;
	ELSE
	   RETURN EOF;
   ELSE
	RETURN PUTCHAR('\N');
}
/*		*/


GETCHAR()
{
   RETURN PUTCHAR (GETCH());
}
/*		*/
AGETCH()
{
   STATIC INT C;
   IF ( C == '\R')
	IF ( (C= GETCH()) != '\N')
	   GOTO CHP;
   C= GETCH();
 CHP:
   IF ( C != '\R')
	IF (C != 0X1A)
	   RETURN C;
	ELSE
	   RETURN EOF;
   ELSE
	RETURN ('\N');
}
/*		*/
UNGETCHAR(C)
INT C;
{
   IF (XXXZEI)
	{
	UNGVAR[1] = C;
	XXXZEI= 2;
	}
   ELSE
	{
	UNGVAR[0] = C;
	XXXZEI = 1;
	}
   RETURN C;
}
/*	*/
CHRRDY()
{ 
   IF (XXXZEI)
	RETURN 1;
   ;
#if BETRIEBSART == 0

#ASM
	mov	r1,#0
	mov	r0,#1
#ENDASM

#else   



#ASM

	clr	a
	mov	r1,a
	jnb	ri,chrrd1
	inc	a
chrrd1:
	mov	r0,a

#ENDASM


#endif

}
/*		*/
PUTLST(C)
INT C;
{
   RETURN PUTCHAR(C);
}
/*		*/
APUTLST(C)
INT C;
{
   IF ( C + (-'\N') ) ;
   ELSE
	PUTLST('\R');
   RETURN PUTLST(C);
}
/*		*/
PUTAUX(C)
INT C;
{
   RETURN PUTCHAR(C);
}
/*		*/
GETAUX()
{
   RETURN GETCH();
}
/*		*/

