/*
   beispielprogramm zur interruptverarbeitung im grundmodell standardversion
   timer 2 interrupt zaehlt in einem assemblerprogramm eine unsigned variable 
   hoch. im c hauptprogramm kann der zaehlerstand angezeigt werden.
   prozessor: 8052
   wenn _INTERN definiert ist, wird das interne modell benutzt.
   xxxmain  muss speziell eingerichtet werden.[als t2intx.asm]

t2intx.asm/t2intxc.asm:
 in xxxmain.asm wird die interruptbehandlung aktiviert (if 1  statt  if 0 )
 und ausgetauscht:
 aus
	org	2bh
			;timer2 interrupt (8052)
	reti
	nop
	nop
 wird
	org	2bh
			;timer2 interrupt (8052)
	extrn	t2int_
	ljmp	t2int_

compilieren:
grundmodell:
 CC51 /S0. %1
 ca51 /2.0 %1
 cl /xsc0 /ot2int.hex t2intx t2int cc

2. internes modell:
 CC51 /"_INTERN"mS0. %1
 ca51 /2.0 %1
 cl /xsc0 /ot2int.hex t2intxc t2int ccc

 */

#include "8052def.c"


/* zaehler */
unsigned tick;

main()
{
   static char str[7];

/* zaehler auf 0 setzen */
   tick= 0;
/* initialisiere timer 2 */
   t2ini();

/* schleife: anzeigen bei eingabe von lerezeichen, ende bei anderem zeichen */
   while (1)
    {
outs("\r\nZaehlerstand wird angezeigt, wenn Leertaste gedrueckt wird !\r\n");
    if (getchar() == ' ')
	{
	outs ("\r\nzaehler: ");
	itoa (gtick(),str);
	outs (str);
	}
    else
	break;
    }

/* stoppe timer */
   t2fini();
}

outs (str)
char *str;
{
   while (*str)
	putchar (*str++);
}

t2ini() 
{
/* zeitkonstanten */
   RCAP2L= 0xff;
   RCAP2H= 0x80;
   TL2= 0;
   TH2= 0x80;
/* timer modus */
   T2CON= 0;
/* enable all + timer2 interrupt */
   IE= 0xa0;
/* starte timer */
   TR2= 1;

}

t2fini() 
{
/* stoppe timer */
   ET2= 0;
/* disable all */
   IE= 0x00;

}

/* lese zaehler */
gtick()
{
   static unsigned u;
   ET2= 0;
   u= tick;
   ET2= 1;
   return u;
}

/* interruptprogramm */
#ifndef _INTERN
#asm
	public	t2int_
t2int_:
;sichere die benutzten register
	push	acc
	push	psw
	push	dpl
	push	dph
;
;zaehler hochzaehlen
	mov	dptr,#.tick
	movx	a,@dptr
	add	a,#1
	movx	@dptr,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0
	movx	@dptr,a
;
	clr	TF2
;
;restauriere register
	pop	dph
	pop	dpl
	pop	psw
	pop	acc
;
;return von interrupt
	reti
#endasm

#else _INTERN

#asm
	public	t2int_
t2int_:
;sichere die benutzten register
	push	acc
	push	psw
;
;zaehler hochzaehlen
	mov	a,.tick
	add	a,#1
	mov	.tick,a
	mov	a,.tick+1
	addc	a,#0
	mov	.tick+1,a
;
	clr	TF2
;
;restauriere register
	pop	psw
	pop	acc
;
;return von interrupt
	reti
#endasm


#endif _INTERN



