	TITLE	XXXMAIN.ASM

	public	_exit,@spxl,@spxh
	ext	xxxini,memmax,imemmax:byte,@spxtop
	ext	@xxioini
	ext	main

;-----------------------
; DEFINITIONEN IM INTERNEN RAM:

xxyreg	segment intern		; INTERNE DATEN fuer mixmode
xxxreg	segment intern		; INTERNE DATEN BEGINNEN AB 20H
;
spx	equ	$		; ENTHAELT WERT DES EXTERNEN STACK-
@spxl	ds	1		; POINTERS
@spxh	ds	1
				; NAECHSTE FREIE ADRESSE IM INTERNEN RAM
				; WIRD BEI 'KLEINEM MODELL' EXTERN DEFINIERT

; STARTWERT DES STACKPOINTERS IM INTERNEN DATENBEREICH:
sptop	equ	imemmax-1	; DER INTERNE STACK LAEUFT NACH OBEN

	cseg

	if 0
;wenn interrupts benutzt werden, kann dieser programmteil aktiviert werden.
;die spruenge zu den adressen der interruptroutinen muessen an den entsprechen-
;den positionen eingetragen werden.

			;reset
	ljmp	xwa
			;externer interrupt 0
	reti
	nop
	nop
	org	0bh
			;timer 0 interrupt
	reti
	nop
	nop
	org	13h
			;externer interrupt 1
	reti
	nop
	nop
	org	1bh
			;timer 1 interrupt
	reti
	nop
	nop
	org	23h
			;serieller port interrupt
	reti
	nop
	nop
	
	org	2bh
			;timer2 interrupt (8052)
	reti
	nop
	nop
	
xwa:
	endif

	mov	sp,#sptop		; INTERNEN STACKPOINTER LADEN
;
;-------------------------
; DEFINITIONEN FUER DAS EXTERNE RAM:

; STARTWERT DES STACKPOINTERS IM EXTERNEN DATENBEREICH:
spmin	equ	1000H		
				; SPMIN IST DIE MINIMALE STACKGROESSE
				; UND KANN VOM BENUTZER VERAENDERT WERDEN.
				; JEDER MODUL KANN ZUSAETZLICHEN STACK
				; RESERVIEREN.
				; DER EXTERNE STACK LAEUFT NACH UNTEN
;
	mov	@spxl,#LOW @spxtop	; EXTERNEN STACKPOINTER  LADEN
	mov	@spxh,#HIGH @spxtop	
;
; 
;--------------------
; WENN KONSTANTE AUS ctns NICHT EIN EIGENES ROM IM DATENBEREICH HABEN,
; UND NICHT MIT DER OPTION 1 GELINKT WIRD (GEMEINSAME ADRESSIERUNG CODE/DATEN),
; WERDEN SIE IM PROGRAMMBEREICH ABGELEGT, UND BEI PROGRAMMSTART IN
; DEN DATENBEREICH KOPIERT.
	if 1	; if 0  fuer Option 1 beim Linken
	extern	@_ctns,@@_ctns
;
	mov	r0,#low @_ctns		;start rom -> r1,r0
	mov	r1,#high @_ctns
;
	mov	r4,#low canf		;start ram -> r5,r4
	mov	r5,#high canf
;
	clr	c			;laenge -> r3,r2
	mov	a,#low @@_ctns
	subb	a,r0
	mov	r2,a
	mov	a,#high @@_ctns
	subb	a,r1
	mov	r3,a
;
lop:
	mov	a,r2			;alles kopiert ?
	orl	a,r3
	jz	kend
;
	mov	dpl,r0
	mov	dph,r1
	clr	a
	movc	a,@a+dptr
	mov	dpl,r4
	mov	dph,r5
	movx	@dptr,a
;
	clr	c			;zaehler dekrementieren
	mov	a,r2
	subb	a,#1
	mov	r2,a
	mov	a,r3
	subb	a,#0
	mov	r3,a
;
	mov	a,r0			;pointer inkrementieren
	add	a,#1
	mov	r0,a
	mov	a,r1
	addc	a,#0
	mov	r1,a
	mov	a,r4			;pointer inkrementieren
	add	a,#1
	mov	r4,a
	mov	a,r5
	addc	a,#0
	mov	r5,a
	sjmp	lop
kend:
	endif

;wenn der nicht initialisierte Datenbereich mit 0 vorbesetzt werden soll, 
;kann dieser Programmteil aktiviert werden.
	if 0
	mov	dptr,#dsanf
uga:
	mov	a,dph			;ende erreicht?
	cjne	a,#high memmax,ugl
	mov	a,dpl
	cjne	a,#low memmax,ugl
	sjmp	uge
ugl:
	mov	a,#0			;fuelle mit 0
	movx	@dptr,a
	inc	dptr
	sjmp	uga
uge:
	endif
;
;------------------
;;; HIER KANN NOCH EIN VERGLEICH VON spx MIT MEMMAX EINGEBAUT WERDEN
;------------------
;
	lcall	xxxini

; Wenn die Terminal Ein-/Ausgabe benutzt wird, ist die folgende 
; Initialisierung noetig. (Andernfalls sollte sie entfernt werden.)
; (siehe auch CHIO.ASM)
; Fuer die Betriebsarten 1+3 gilt bei 11.0592 MHz Prozessortakt :

	if	1
	public	@baud
@baud	EQU	-3	;9600 baud
;@baud	EQU	-6	;4800
;@baud	EQU	-12	;2400
;@baud	equ	-24	;1200
	lcall	@xxioini
	endif
;
	lcall	main

_exit:
	ljmp	0
	sjmp	_exit

ctns	segment
canf	equ	$

	dseg
dsanf	equ	$

@stack	segment
	ds	spmin
	end
